Debian Bug report logs - #523846
No IPv6 support

version graph

Package: munin; Maintainer for munin is Munin Debian Maintainers <packaging@munin-monitoring.org>; Source for munin is src:munin.

Reported by: Brian May <brian@microcomaustralia.com.au>

Date: Mon, 13 Apr 2009 00:57:01 UTC

Severity: normal

Tags: fixed-upstream, ipv6, patch, sid, squeeze, wheezy

Found in versions munin/1.4.5-3, libnet-server-perl/0.99-3

Done: gregor herrmann <gregoa@debian.org>

Bug is archived. No further changes may be made.

Forwarded to http://munin-monitoring.org/ticket/358

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#523846; Package libnet-server-perl. (Mon, 13 Apr 2009 00:57:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Brian May <brian@microcomaustralia.com.au>:
New Bug report received and forwarded. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Mon, 13 Apr 2009 00:57:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Brian May <brian@microcomaustralia.com.au>
To: submit@bugs.debian.org
Subject: No IPv6 support
Date: Mon, 13 Apr 2009 10:55:31 +1000
Package: libnet-server-perl
Version: 0.97-1
Tags: ipv6

This affects any package that uses libnet-server-perl, such as munin.

Upstream references:
* <http://munin.projects.linpro.no/ticket/358>
* <http://rt.cpan.org/Public/Bug/Display.html?id=33289>

This would appear to be a libnet-server-perl issue despite the fact the 
suggested patch was posted to the munin bug report ;-).

-- 
Brian May <brian@microcomaustralia.com.au>





Information forwarded to debian-bugs-dist@lists.debian.org, Alexander Wirt <formorer@debian.org>, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#523846; Package libnet-server-perl. (Mon, 04 May 2009 09:24:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to sean finney <seanius@debian.org>:
Extra info received and forwarded to list. Copy sent to Alexander Wirt <formorer@debian.org>, Carsten Wolff <carsten@wolffcarsten.de>. (Mon, 04 May 2009 09:24:05 GMT) Full text and rfc822 format available.

Message #10 received at 523846@bugs.debian.org (full text, mbox):

From: sean finney <seanius@debian.org>
To: Debian Bug Tracking System <523846@bugs.debian.org>
Subject: libnet-server-perl: better patch
Date: Mon, 04 May 2009 11:18:39 +0200
[Message part 1 (text/plain, inline)]
Package: libnet-server-perl
Version: 0.97-1.1
Severity: normal

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

tags 523846 patch
thanks

hi,

i was doing some digging into this issue myself, and found that the patch
from the munin BR doesn't work (as mentioned in the munin BR, something more
needs to be done wrt unpacking the sockaddr_in's).

i stumbled across a more complete patch that someone else had thrown together,
though it was against a slightly older version of the codebase.  so i've
updated and massaged the code a bit, and have a patch that works for my
purposes (attached).  further comments can be found in the patch contents.


	sean

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iD8DBQFJ/rLtynjLPm522B0RAnjvAJ9k+HAsAqRGP3GpP1Ofh7KzwknK2gCcCb+/
sKozhCh0CVWdbarLJ1WDu+A=
=gzWu
-----END PGP SIGNATURE-----
[03_ipv6-support.dpatch (text/x-shellscript, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#523846; Package libnet-server-perl. (Mon, 04 May 2009 09:24:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to sean finney <seanius@debian.org>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Mon, 04 May 2009 09:24:06 GMT) Full text and rfc822 format available.

Message #15 received at 523846@bugs.debian.org (full text, mbox):

From: sean finney <seanius@debian.org>
To: Debian Bug Tracking System <523846@bugs.debian.org>
Subject: Re: libnet-server-perl: better patch
Date: Mon, 4 May 2009 11:22:31 +0200
[Message part 1 (text/plain, inline)]
oh,  one more thing:

On Mon, May 04, 2009 at 11:18:39AM +0200, sean finney wrote:
> ## DP: the latest version of Net-Server in debian, modified for new stricter 
> ## DP: perl syntax conventions, and a small bugfix to the original patch in
> ## DP: the last hunk.

in case you get confused, there is no "small bugfix" in the last hunk, i
thought the INET/INET6 stuff needed to be conditionally seperated there
but was wrong[1] and forgot to update the patch comments.


	sean

[1] afaict the Socket6 code will happily work with ipv4 sockets too.
[signature.asc (application/pgp-signature, inline)]

Tags added: patch Request was from Sean Finney <seanius@debian.org> to control@bugs.debian.org. (Mon, 04 May 2009 09:24:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#523846; Package libnet-server-perl. (Mon, 04 May 2009 12:12:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to sean finney <seanius@debian.org>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Mon, 04 May 2009 12:12:05 GMT) Full text and rfc822 format available.

Message #22 received at 523846@bugs.debian.org (full text, mbox):

From: sean finney <seanius@debian.org>
To: Debian Bug Tracking System <523846@bugs.debian.org>
Cc: Alexander Wirt <formorer@debian.org>
Subject: libnet-server-perl: updated patch
Date: Mon, 4 May 2009 14:11:12 +0200
[Message part 1 (text/plain, inline)]
Package: libnet-server-perl
Version: 0.97-1.1
Severity: normal

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

the previous patch also needed an explicit import of the inet_ntop
method, updated patch included.

i've tested this version with a modified copy of the udp echo client
and it seems to work.  i'm still having trouble getting the particular
client motivating this work (spampd) to work, but this could possibly be
due to problems with the particular app.


	sean

- -- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.26-2-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.utf8, LC_CTYPE=en_US.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages libnet-server-perl depends on:
ii  libio-multiplex-perl          1.10-1     object-oriented interface to selec
ii  libnet-cidr-perl              0.13-1     Manipulate IPv4/IPv6 netblocks in 
ii  perl                          5.10.0-19  Larry Wall's Practical Extraction 

libnet-server-perl recommends no packages.

Versions of packages libnet-server-perl suggests:
ii  libio-socket-ssl-perl         1.24-1     Perl module implementing object or

- -- no debconf information

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iD8DBQFJ/trfynjLPm522B0RAkzHAJ0ebqtU8KlD5pRXNuDJD8tR35MH4ACbB9B7
gFDgCh+t5PM0kcySYc2+vZk=
=b6bw
-----END PGP SIGNATURE-----
[03_ipv6-support.dpatch (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#523846; Package libnet-server-perl. (Mon, 04 May 2009 17:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to sean finney <seanius@debian.org>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Mon, 04 May 2009 17:33:02 GMT) Full text and rfc822 format available.

Message #27 received at 523846@bugs.debian.org (full text, mbox):

From: sean finney <seanius@debian.org>
To: 523846@bugs.debian.org
Cc: Alexander Wirt <formorer@debian.org>
Subject: Re: Bug#523846: Info received (libnet-server-perl: better patch)
Date: Mon, 4 May 2009 19:31:52 +0200
[Message part 1 (text/plain, inline)]
hi once more,

the last patch should be correct.  *however*, the problems i was mentioning 
were the result of a bug in another package, which i strongly suggest
you take into account with this upload.  namely, see #522478 .  uploading
without also waiting for the NMU'd version of libio-socket-inet6-perl
(i put it in 2-day earlier this afternoon) will probably result in
breaking a lot of stuff on any systems that have working ipv6 (or maybe
totally!)

therefore, i recommend that you also add a versioned depends on
libio-socket-inet6-perl (>= 2.54-1.1) so the package won't be installable
until the NMU makes its way in too.


	sean
[signature.asc (application/pgp-signature, inline)]

Tags added: pending Request was from Alexander Wirt <formorer@debian.org> to control@bugs.debian.org. (Mon, 20 Jul 2009 05:45:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#523846; Package libnet-server-perl. (Thu, 11 Mar 2010 21:30:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Kahn Gillmor <dkg@fifthhorseman.net>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Thu, 11 Mar 2010 21:30:07 GMT) Full text and rfc822 format available.

Message #34 received at 523846@bugs.debian.org (full text, mbox):

From: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
To: 523846@bugs.debian.org, 523846-submitter@bugs.debian.org
Subject: is #523846 still pending?
Date: Thu, 11 Mar 2010 16:27:50 -0500
[Message part 1 (text/plain, inline)]
Hi Folks--

I note that #523846 was marked as pending back in July 2009.  Is that
still the case?  What's going on with this issue?

Thanks for keeping Net::Server in debian!

	--dkg

[signature.asc (application/pgp-signature, attachment)]

Message sent on to Brian May <brian@microcomaustralia.com.au>:
Bug#523846. (Thu, 11 Mar 2010 21:30:19 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'normal' Request was from Clint Adams <schizo@debian.org> to control@bugs.debian.org. (Tue, 23 Mar 2010 01:04:14 GMT) Full text and rfc822 format available.

Added tag(s) sid and squeeze. Request was from Gerfried Fuchs <rhonda@debian.at> to control@bugs.debian.org. (Tue, 23 Mar 2010 07:51:35 GMT) Full text and rfc822 format available.

Severity set to 'normal' from 'serious' Request was from Gerfried Fuchs <rhonda@deb.at> to control@bugs.debian.org. (Tue, 23 Mar 2010 08:31:17 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#523846; Package libnet-server-perl. (Tue, 29 Jun 2010 13:09:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Kiss Gabor (Bitman)" <kissg@ssg.ki.iif.hu>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Tue, 29 Jun 2010 13:09:09 GMT) Full text and rfc822 format available.

Message #48 received at 523846@bugs.debian.org (full text, mbox):

From: "Kiss Gabor (Bitman)" <kissg@ssg.ki.iif.hu>
To: 523846@bugs.debian.org
Subject: IPv6 patch is incorrect
Date: Tue, 29 Jun 2010 15:07:49 +0200 (CEST)
03_ipv6-support.dpatch introduces a call to inet_pton:

     if( defined $prop->{reverse_lookups} ){
-      $prop->{peerhost} = gethostbyaddr( inet_aton($prop->{peeraddr}), AF_INET );
+      $prop->{peerhost} = ( (length($sockname) > 16) ? gethostbyaddr( inet_pton(AF_INET6, $prop->{peeraddr}), AF_INET6 ) : gethostbyaddr( inet_aton($prop->{peeraddr}), AF_INET ) );
     }

but doest not import it from Socket6:

-use Socket qw(inet_aton inet_ntoa AF_INET AF_UNIX SOCK_DGRAM SOCK_STREAM);
+use Socket qw(inet_aton inet_ntoa AF_INET AF_INET6 AF_UNIX SOCK_DGRAM SOCK_STREAM);
+use Socket6 qw(inet_ntop);

So if reverse_lookups is enabled error messages come:

Undefined subroutine &Net::Server::inet_pton called at /usr/share/perl5/Net/Server.pm line 773.

Gabor




Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#523846; Package libnet-server-perl. (Tue, 29 Jun 2010 16:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Kiss Gabor (Bitman)" <kissg@ssg.ki.iif.hu>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Tue, 29 Jun 2010 16:03:06 GMT) Full text and rfc822 format available.

Message #53 received at 523846@bugs.debian.org (full text, mbox):

From: "Kiss Gabor (Bitman)" <kissg@ssg.ki.iif.hu>
To: 523846@bugs.debian.org
Subject: IPv6 patch is incomplete
Date: Tue, 29 Jun 2010 17:59:51 +0200 (CEST)
File /usr/share/perl5/Net/Server.pm, line 1487:

  if ($#{ $prop->{cidr_allow} } != -1) {
    require Net::CIDR;
    return 1 if Net::CIDR::cidrlookup($prop->{peeraddr}, @{ $prop->{cidr_allow} });
  }

Assume config contains this:
cidr_allow 192.168.163.0/24

At this point I can see that 
$prop->{cidr_allow} is ['192.168.163.0/24']
meanwhile
$prop->{peeraddr} is '::ffff:192.168.163.47'

This is an IPv4-Mapped IPv6 Address

Poor Net::CIDR::cidrlookup() thinks that ::ffff:192.168.163.47 is
an IPv6 address and complains:

	Invalid netblock: 192.168.163.255-0.0.0.0.0.0.0.0.0.0.255.255.193.6.222.47 at /usr/share/perl5/Net/Server.pm line 831

A workaround may be cutting '::ffff:' prefix from front of IPv4 addresses
before giving them to cidrlookup().

Giving IPv4-Mapped IPv6 Address in the config file might be an other
solution but
cidr_allow ::ffff:192.168.163.0/120
does not work yet, because process_conf() cuts off the first colon if found
thinking user wrote like this:
cidr_allow: blahblahblah
So if I write this:
cidr_allow: ::ffff:192.168.163.0/120
it works finally.

But how ugly is it. :-(

Gabor

-- 
No smoke, no drugs, no vindoze.




Added tag(s) wheezy. Request was from Kurt Roeckx <kurt@roeckx.be> to control@bugs.debian.org. (Wed, 16 Feb 2011 19:03:22 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#523846; Package libnet-server-perl. (Thu, 07 Apr 2011 14:35:23 GMT) Full text and rfc822 format available.

Acknowledgement sent to Carsten Wolff <carsten@wolffcarsten.de>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Thu, 07 Apr 2011 14:35:34 GMT) Full text and rfc822 format available.

Message #60 received at 523846@bugs.debian.org (full text, mbox):

From: Carsten Wolff <carsten@wolffcarsten.de>
To: 523846@bugs.debian.org
Subject: Re: No IPv6 support
Date: Thu, 7 Apr 2011 16:08:46 +0200
[Message part 1 (text/plain, inline)]
Package: munin
Version: 1.4.5-3

Hi,

On Monday 13 April 2009, Brian May wrote:
> Package: libnet-server-perl
> Version: 0.97-1
> Tags: ipv6
> 
> This affects any package that uses libnet-server-perl, such as munin.
> 
> Upstream references:
> * <http://munin.projects.linpro.no/ticket/358>
> * <http://rt.cpan.org/Public/Bug/Display.html?id=33289>
> 
> This would appear to be a libnet-server-perl issue despite the fact the
> suggested patch was posted to the munin bug report ;-).

I've worked on the Net::Server patch a little more and committed it to the 
pkg-perl repo. That means, with the next upload of libnet-server-perl, munin-
node will be able to use IPv6.

Of course, munin-update also needs to be able to do so, so I did a quick patch 
for testing purposes and it worked for me(tm). It's possibly not enough, 
though, so please only take it as a suggestion.

Cheers,
Carsten
-- 
           /\-´-/\
          (  @ @  )
________o0O___^___O0o________
[munin-update-ipv6.diff (text/x-patch, attachment)]
[signature.asc (application/pgp-signature, inline)]

Bug reassigned from package 'libnet-server-perl' to 'munin'. Request was from Carsten Wolff <carsten@wolffcarsten.de> to control@bugs.debian.org. (Fri, 08 Apr 2011 09:06:31 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions 0.97-1.1, munin/1.4.5-3, and libnet-server-perl/0.97-1. Request was from Carsten Wolff <carsten@wolffcarsten.de> to control@bugs.debian.org. (Fri, 08 Apr 2011 09:06:32 GMT) Full text and rfc822 format available.

Bug Marked as found in versions munin/1.4.5-3. Request was from Micha Lenk <micha@debian.org> to control@bugs.debian.org. (Fri, 08 Apr 2011 17:36:25 GMT) Full text and rfc822 format available.

Removed tag(s) pending. Request was from Micha Lenk <micha@debian.org> to control@bugs.debian.org. (Fri, 08 Apr 2011 17:51:08 GMT) Full text and rfc822 format available.

Set Bug forwarded-to-address to 'http://munin-monitoring.org/ticket/358'. Request was from Holger Levsen <holger@layer-acht.org> to control@bugs.debian.org. (Tue, 30 Aug 2011 15:27:07 GMT) Full text and rfc822 format available.

Added tag(s) fixed-upstream. Request was from bts-link-upstream@lists.alioth.debian.org to control@bugs.debian.org. (Mon, 05 Sep 2011 16:42:13 GMT) Full text and rfc822 format available.

Reply sent to gregor herrmann <gregoa@debian.org>:
You have taken responsibility. (Tue, 20 Sep 2011 20:51:05 GMT) Full text and rfc822 format available.

Notification sent to Brian May <brian@microcomaustralia.com.au>:
Bug acknowledged by developer. (Tue, 20 Sep 2011 20:51:05 GMT) Full text and rfc822 format available.

Message #77 received at 523846-close@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: 523846-close@bugs.debian.org
Subject: Bug#523846: fixed in libnet-server-perl 0.99-3
Date: Tue, 20 Sep 2011 20:49:13 +0000
Source: libnet-server-perl
Source-Version: 0.99-3

We believe that the bug you reported is fixed in the latest version of
libnet-server-perl, which is due to be installed in the Debian FTP archive:

libnet-server-perl_0.99-3.debian.tar.gz
  to main/libn/libnet-server-perl/libnet-server-perl_0.99-3.debian.tar.gz
libnet-server-perl_0.99-3.dsc
  to main/libn/libnet-server-perl/libnet-server-perl_0.99-3.dsc
libnet-server-perl_0.99-3_all.deb
  to main/libn/libnet-server-perl/libnet-server-perl_0.99-3_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 523846@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
gregor herrmann <gregoa@debian.org> (supplier of updated libnet-server-perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Tue, 20 Sep 2011 22:04:38 +0200
Source: libnet-server-perl
Binary: libnet-server-perl
Architecture: source all
Version: 0.99-3
Distribution: unstable
Urgency: low
Maintainer: Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>
Changed-By: gregor herrmann <gregoa@debian.org>
Description: 
 libnet-server-perl - extensible, general perl server engine
Closes: 523846 642175
Changes: 
 libnet-server-perl (0.99-3) unstable; urgency=low
 .
   [ Carsten Wolff ]
   * took IPv6 patch from bug report, improved and included it
     as 05_ipv6-support.dpatch.
     (closes: Bug#523846)
   * added depends introduced by above patch
   * created patch 06_cidr-workaround.dpatch as a workaround
     until Net::CIDR is fixed
 .
   [ Ansgar Burchardt ]
   * debian/control: Convert Vcs-* fields to Git.
 .
   [ Salvatore Bonaccorso ]
   * debian/copyright: Replace DEP5 Format-Specification URL from
     svn.debian.org to anonscm.debian.org URL.
 .
   [ gregor herrmann ]
   * Drop ancient patch 02_spec.dpatch which causes a FTBFS. Thanks to
     Allison Randal for the bug report and the thorough analysis.
     (Closes: #642175)
   * Switch to source format 3.0 (quilt).
   * Convert remaining patches to quilt.
   * Use tiny debian/rules file, and debhelper 8.
   * Remove version from perl build dependency and move it to Build-
     Depends-Indep.
   * Set Standards-Version to 3.9.2 (no further changes).
   * debian/copyright: update formatting.
   * Add /me to Uploaders.
   * Remove leading article from short description.
   * Add a new patch to fix a spelling mistake in the POD.
Checksums-Sha1: 
 ac413a2fe78095cd068204516dc82eecca57180d 2083 libnet-server-perl_0.99-3.dsc
 dba9ae117d80f951df818463cac65d6d593104cd 7579 libnet-server-perl_0.99-3.debian.tar.gz
 8808e120b66acd98b042418a754332ed162b26c3 159398 libnet-server-perl_0.99-3_all.deb
Checksums-Sha256: 
 beac95662e30fd570854df9d5a95b353bf40ada6cbd339c50035be50dd19b471 2083 libnet-server-perl_0.99-3.dsc
 d5d44fecd788e447fe70a37933f130e173f21f69b4ab38a31883f90ba969bb6e 7579 libnet-server-perl_0.99-3.debian.tar.gz
 a0b061a07d4fc8191bc9c93069ade66361ba7cea8cad6e7d3240e1d135545052 159398 libnet-server-perl_0.99-3_all.deb
Files: 
 c904fb9b7001ebabc5bc4cfd93b10ece 2083 perl optional libnet-server-perl_0.99-3.dsc
 fa89bf43ce9fc49b7b4fbe7f9a61291c 7579 perl optional libnet-server-perl_0.99-3.debian.tar.gz
 80d89ddf406ce210a42e0187adbe578f 159398 perl optional libnet-server-perl_0.99-3_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iQIcBAEBCAAGBQJOePLzAAoJELs6aAGGSaoGSW4P/j3ZRGem4Hx6axrfb6xuniPA
m5htsKGpVU9c9Iit7+GAaKF+6zdBc2iIcufxrO6LtWEV9NbZPHL4C0R8KlrMcp3J
Sn9owzrewuc6mXBbGDczdJdjJhpq2R3BJK0AVzDVm61+45PpiXgciXRtJ+itrp2E
2LBYXfvhc3kTY4i5d+sQ0EIrXZiXJi75HFTkINYtM+a/elpOCNyRcGGKQB3EyqjQ
GyDa6fCViN47Mai2R7V/5MQSZJStzicqdjvOWKnTkgc0eDwBw4PctZOJcj91WAcF
lSvnuidKTmwRE49HJj3SR+RQSpC1h4xVo+sVeKfn0eYQmI10bmFRV3FvtbHp52T/
yOjSDkcGgVxRsSHKIcwmQ8Ch0CIOvuzfJEMLT9FYyncJenjU3uuDtUvmMVA9xTFd
TwIDY2Rcx0eM0lWQyyI6PUci7F2uI/aqcHz9UmQbMUzK+/tdmHUt4/hCrZDU/D4e
1CFpo56xzKD7KYnRySbnIlcj8gW8ekT8QKbB+Q/rp17k3SE4Cn+DGVX6UgwCM/qu
bz5fMliHyXgULks6XcJvObvwiVe6RujQ+gNlPvvjJuH11VfDblKuzfr/Z91Y6oBI
e17zGIsr5oSP7GSBeYi5ZJ4a/W/Lagv5cNDu6Xx7qQwXke5VBFvMP4hhkeHKErMJ
hSw/6A5xGmFOdW1YUieT
=MO33
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 11:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Sanders <cas@taz.net.au>:
Extra info received and forwarded to list. Copy sent to Munin Debian Maintainers <munin-deb-maint@linpro.no>. (Wed, 28 Sep 2011 11:30:09 GMT) Full text and rfc822 format available.

Message #82 received at 523846@bugs.debian.org (full text, mbox):

From: Craig Sanders <cas@taz.net.au>
To: submit@bugs.debian.org
Cc: 523846@bugs.debian.org
Subject: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 21:18:26 +1000
Package: libnet-server-perl
Version: 0.99-3

i've got several systems running munin-node, and those that have had
munin-node restarted recently are listening ONLY on ipv6.  Those that
have been running since approx Sep 19 are listening correctly on ipv4.

All are running munin-node 1.4.6-1, and all are kept up-to-date with
debian sid. all upgraded today, but munin-node was only restarted on
some. the most likely culprit is libnet-server-perl which was upgraded
from 0.99-2 to 0.99-3 around September 20.

changelog.Debian.gz for libnet-server-perl mentions:

  * took IPv6 patch from bug report, improved and included it as 05_ipv6-support.dpatch.  (closes: Bug#523846)

ipv6 support is nice i suppose, but not at the expense of ipv4 support.


e.g.

kali:/etc/munin# netstat -tupan | grep munin
tcp        0      0 0.0.0.0:4949            0.0.0.0:*               LISTEN      2646/munin-node

kali:/etc/munin# ps aux | grep [m]unin
root      2646  0.0  0.0  44328  8624 ?        Ss   Sep19   0:55 /usr/sbin/munin-node


ganesh:/etc/munin# netstat -tupan | grep munin
tcp6       0      0 :::4949                 :::*                    LISTEN      8301/munin-node

ganesh:/etc/munin# ps aux | grep [m]unin
root      8301  0.0  0.0  49676 10300 ?        Ss   20:20   0:00 /usr/sbin/munin-node


Both systems above (in fact, all my systems) are configured with 'host
*' in munin-node.conf.  I have forced one machine to listen on ipv4 by
putting 'host ip.ip.ip.ip' in munin-node.conf - but that only allows it
to listen on ONE ipv4 address, not all of them. worse, i would have to
maintain individual munin-node.conf files for each machine rather than
just scp or pdcp the same munin-node.conf to every box.


this may be a bug in libnet-server-perl, or it may be a bug in
munin-node (might need changes to cope with lbnet-server-perl
0.99-3).  I can't tell. feel free to reassign this bug if it belongs
to munin-node. or merge this report into #523846 if that's more
appropriate.


[5 mins later]

BTW, downgrading to libnet-server-perl 0.99-2 does fix the problem, so
i'm submitting this for libnet-server-perl rather than munin-node (i was
originally going to submit it for munin-node 1.46-1)

ganesh:/# dpkg -i /export/ftp/debian/pool/main/libn/libnet-server-perl/libnet-server-perl_0.99-2_all.deb
dpkg: warning: downgrading libnet-server-perl from 0.99-3 to 0.99-2.
(Reading database ... 878378 files and directories currently installed.)
Preparing to replace libnet-server-perl 0.99-3 (using .../libnet-server-perl_0.99-2_all.deb) ...
Unpacking replacement libnet-server-perl ...
Setting up libnet-server-perl (0.99-2) ...
Processing triggers for man-db ...

ganesh:/# /etc/init.d/munin-node restart
Stopping Munin-Node: done.
Starting Munin-Node: done.

ganesh:/# netstat -tupan | grep munin
tcp        0      0 0.0.0.0:4949            0.0.0.0:*               LISTEN      14875/munin-node


craig

-- 
craig sanders <cas@taz.net.au>




Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 11:30:15 GMT) Full text and rfc822 format available.

Message #85 received at 523846@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: Craig Sanders <cas@taz.net.au>, 643654@bugs.debian.org
Cc: 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 14:29:38 +0300
[Message part 1 (text/plain, inline)]
-=| Craig Sanders, 28.09.2011 21:18:26 +1000 |=-
> Package: libnet-server-perl
> Version: 0.99-3
> 
> i've got several systems running munin-node, and those that have had
> munin-node restarted recently are listening ONLY on ipv6.  Those that
> have been running since approx Sep 19 are listening correctly on ipv4.
> 
> ganesh:/etc/munin# netstat -tupan | grep munin
> tcp6       0      0 :::4949                 :::*                    LISTEN      8301/munin-node

I have that too, but I am still able to connect on the regular ipv4 
address.

Are you really unable to connect to the ipv4 addresses?
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 12:17:50 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Sanders <cas@taz.net.au>:
Extra info received and forwarded to list. Copy sent to Munin Debian Maintainers <munin-deb-maint@linpro.no>. (Wed, 28 Sep 2011 12:18:17 GMT) Full text and rfc822 format available.

Message #90 received at 523846@bugs.debian.org (full text, mbox):

From: Craig Sanders <cas@taz.net.au>
To: Damyan Ivanov <dmn@debian.org>, 643654@bugs.debian.org, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 22:11:24 +1000
On Wed, Sep 28, 2011 at 02:29:38PM +0300, Damyan Ivanov wrote:
> > i've got several systems running munin-node, and those that have had
> > munin-node restarted recently are listening ONLY on ipv6.  Those that
> > have been running since approx Sep 19 are listening correctly on ipv4.
> > 
> > ganesh:/etc/munin# netstat -tupan | grep munin
> > tcp6       0      0 :::4949                 :::*                    LISTEN      8301/munin-node
> 
> I have that too, but I am still able to connect on the regular ipv4 
> address.
> 
> Are you really unable to connect to the ipv4 addresses?

nope. i can't even telnet to 127.0.0.1:4949 or to $hostname:4949 (so the
munin server can't connect to gather data).

as i said, i can force munin-node to listen on a single ipv4 address
with 'host ip.ip.ip.ip' in /etc/munin/munin-node.conf but if that
setting is left at the default 'host *', then it will ONLY listen on
ipv6 addresses since libnet-server-perl was upgraded to 0.99-3

downgrading libnet-server-perl to 0.99-2 fixes the problem.

craig

-- 
craig sanders <cas@taz.net.au>

BOFH excuse #58:

high pressure system failure




Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 12:26:20 GMT) Full text and rfc822 format available.

Message #93 received at 523846@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: Craig Sanders <cas@taz.net.au>
Cc: 643654@bugs.debian.org, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 15:23:34 +0300
[Message part 1 (text/plain, inline)]
-=| Craig Sanders, 28.09.2011 22:11:24 +1000 |=-
> On Wed, Sep 28, 2011 at 02:29:38PM +0300, Damyan Ivanov wrote:
> > > i've got several systems running munin-node, and those that have had
> > > munin-node restarted recently are listening ONLY on ipv6.  Those that
> > > have been running since approx Sep 19 are listening correctly on ipv4.
> > > 
> > > ganesh:/etc/munin# netstat -tupan | grep munin
> > > tcp6       0      0 :::4949                 :::*                    LISTEN      8301/munin-node
> > 
> > I have that too, but I am still able to connect on the regular ipv4 
> > address.
> > 
> > Are you really unable to connect to the ipv4 addresses?
> 
> nope. i can't even telnet to 127.0.0.1:4949 or to $hostname:4949 (so the
> munin server can't connect to gather data).
> 
> as i said, i can force munin-node to listen on a single ipv4 address
> with 'host ip.ip.ip.ip' in /etc/munin/munin-node.conf but if that
> setting is left at the default 'host *', then it will ONLY listen on
> ipv6 addresses since libnet-server-perl was upgraded to 0.99-3
> 
> downgrading libnet-server-perl to 0.99-2 fixes the problem.

I did read what you wrote :)

Thing is, my munin-node accepts ipv4 connections with exact same 
LISTEN line as yours above. This makes me think there is something 
else different on your system.

Can you try tcpdump and/or strace and see what exactly is happening?
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 14:06:23 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Sanders <cas@taz.net.au>:
Extra info received and forwarded to list. Copy sent to Munin Debian Maintainers <munin-deb-maint@linpro.no>. (Wed, 28 Sep 2011 14:06:23 GMT) Full text and rfc822 format available.

Message #98 received at 523846@bugs.debian.org (full text, mbox):

From: Craig Sanders <cas@taz.net.au>
To: Damyan Ivanov <dmn@debian.org>, 643654@bugs.debian.org, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 23:31:23 +1000
On Wed, Sep 28, 2011 at 03:23:34PM +0300, Damyan Ivanov wrote:
> I did read what you wrote :)

ok, sorry. i assumed you skipped that bit :)

> Thing is, my munin-node accepts ipv4 connections with exact same
> LISTEN line as yours above. 

hmmm...

are you making real use of ipv6 as well as ipv4? or just have inet6
addresses on your NICs because (like me) you haven't bothered disabling
ipv6?

and do you have allow lines in munin-node.conf for ipv6 addresses?

> This makes me think there is something
> else different on your system.

i'd think the same if it was just my main home workstation (which
has been messed about with since i started using debian in '94 -
both hardware and software continuously upgraded, so there's a LOT
of cruft)...but the error is consistent on every system i upgraded
libnet-server-perl and restarted munin-node. even clean new VMs with
hardly anything installed, untinkered with, just plain out-of-the-box
stock debian sid.

> Can you try tcpdump and/or strace and see what exactly is happening?

i could but then i'd break my running munin config :-(

i already lost half a day's stats before i noticed the problem so i'm
not keen to do that right now.

i'll fire up a new VM at work tomorrow and do some more testing. sleep
first :)

craig

-- 
craig sanders <cas@taz.net.au>




Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 17:33:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. Copy sent to Munin Debian Maintainers <munin-deb-maint@linpro.no>. (Wed, 28 Sep 2011 17:33:06 GMT) Full text and rfc822 format available.

Message #103 received at 523846@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: Craig Sanders <cas@taz.net.au>, 643654@bugs.debian.org
Cc: Damyan Ivanov <dmn@debian.org>, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 19:31:45 +0200
[Message part 1 (text/plain, inline)]
tag 643654 + confirmed
severity 643654 important
thanks

On Wed, 28 Sep 2011 22:11:24 +1000, Craig Sanders wrote:

> > > i've got several systems running munin-node, and those that have had
> > > munin-node restarted recently are listening ONLY on ipv6.  Those that
> > > have been running since approx Sep 19 are listening correctly on ipv4.
> > > 
> > > ganesh:/etc/munin# netstat -tupan | grep munin
> > > tcp6       0      0 :::4949                 :::*                    LISTEN      8301/munin-node
> > 
> > I have that too, but I am still able to connect on the regular ipv4 
> > address.
> > 
> > Are you really unable to connect to the ipv4 addresses?
> 
> nope. i can't even telnet to 127.0.0.1:4949 or to $hostname:4949 (so the
> munin server can't connect to gather data).

Seems I can reproduce the problem. Some output to make sure I got
everything right:

root@belanna:~# netstat -tupan | grep munin
tcp6       0      0 :::4949                 :::*                    LISTEN      3037/munin-node 

root@belanna:~# ps aux | grep [m]unin
root      3037  0.0  0.1   8652  2848 ?        Ss   Sep26   0:04 /usr/sbin/munin-node

root@belanna:~# grep host /etc/munin/munin-node.conf | egrep -v ^#
host *

root@belanna:~# telnet 127.0.0.1 4949
Trying 127.0.0.1...
telnet: Unable to connect to remote host: Connection refused

root@belanna:~# telnet ::1 4949
Trying ::1...
Connected to ::1.
Escape character is '^]'.
Connection closed by foreign host.

root@belanna:~# telnet localhost 4949
Trying 127.0.0.1...
telnet: Unable to connect to remote host: Connection refused

root@belanna:~# telnet belanna 4949
Trying 192.168.0.3...
telnet: Unable to connect to remote host: Connection refused

root@belanna:~# telnet 192.168.0.3 4949
Trying 192.168.0.3...
telnet: Unable to connect to remote host: Connection refused

root@belanna:~# telnet 2001:<public ipv6> 4949
Trying 2001:<public ipv6>...
Connected to 2001:<public ipv6>.
Escape character is '^]'.
Connection closed by foreign host.


And indeed, my munin charts for this machines are empty since
Saturday evening when I rebooted the machine because of a new kernel.
(That show how often I actually check them :/)

syslog doesn't help; munin-node.log has

2011/09/24-20:25:03 CONNECT TCP Peer: "192.168.0.252:58636" Local: "192.168.0.3:4949"
[some errors about byte order and ../../lib/Storable.pm]
2011/09/24-20:27:34 Server closing!
Process Backgrounded
2011/09/24-20:29:51 Munin::Node::Server (type Net::Server::Fork) starting! pid(3869)
Using default listen value of 128
Binding to TCP port 4949 on host *
Setting gid to "0 0"

and then nothing until (my telnet attempts before):

2011/09/28-18:17:45 CONNECT TCP Peer: "::1:32798" Local: "::1:4949"
Invalid netblock: 127.255.255.255-0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.1 at /usr/share/perl5/Net/Server.pm line 849
2011/09/28-18:25:32 CONNECT TCP Peer: "2001:15c0:66bc:0:211:11ff:fe92:3e20:33975" Local: "2001:15c0:66bc:0:211:11ff:fe92:3e20:4949"
Invalid netblock: 127.255.255.255-32.1.21.192.102.188.0.0.2.17.17.255.254.146.62.32 at /usr/share/perl5/Net/Server.pm line 849
2011/09/28-18:26:57 CONNECT TCP Peer: "2001:15c0:66bc:0:211:11ff:fe92:3e20:33989" Local: "2001:15c0:66bc:0:211:11ff:fe92:3e20:4949"
Invalid netblock: 127.255.255.255-32.1.21.192.102.188.0.0.2.17.17.255.254.146.62.32 at /usr/share/perl5/Net/Server.pm line 849

(and none of the ipv4 connect attempts)


Random thoughts:
- /usr/share/perl5/Munin/Node/Server.pm uses Net::Server::Fork --
  does usr/share/perl5/Net/Server/Fork.pm need some additional
  treatment? (It's not in the patch.)
- Ansgar mentioned sys.net.ipv6.bindv6only on IRC.

  root@belanna:~# sysctl net.ipv6.bindv6only
  net.ipv6.bindv6only = 1

  Oh, and setting it to 0 changes something:

root@belanna:~# telnet ::1 4949
Trying ::1...
Connected to ::1.
Escape character is '^]'.
Connection closed by foreign host.

root@belanna:~# telnet 127.0.0.1 4949
Trying 127.0.0.1...
Connected to 127.0.0.1.
Escape character is '^]'.
# munin node at belanna.comodo.priv.at
Connection closed by foreign host.

2011/09/28-19:02:17 CONNECT TCP Peer: "::1:33533" Local: "::1:4949"
Invalid netblock: 127.255.255.255-0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.1 at /usr/share/perl5/Net/Server.pm line 849
2011/09/28-19:02:23 CONNECT TCP Peer: "::ffff:127.0.0.1:37569" Local: "::ffff:127.0.0.1:4949"
2011/09/28-19:02:33 [20689] Node side timeout while processing: '<no command received yet>'

So, with net.ipv6.bindv6only = 1 there's no ipv4 connection; with = 0
ipv4 works. And ipv6 works connection-wise in both cases but doesn't
generate a prompt in my telnet attempt?!


Cheers,
gregor


-- 
 .''`.   Homepage: http://info.comodo.priv.at/ - OpenPGP key ID: 0x8649AA06
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT & SPI, fellow of Free Software Foundation Europe
   `-    NP: The Band: The Band With Bob Dylan / Fore
NP: Rolling Stones: Wild Horses
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 18:15:06 GMT) Full text and rfc822 format available.

Message #106 received at 523846@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: gregor herrmann <gregoa@debian.org>
Cc: Craig Sanders <cas@taz.net.au>, 643654@bugs.debian.org, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 21:12:03 +0300
[Message part 1 (text/plain, inline)]
-=| gregor herrmann, 28.09.2011 19:31:45 +0200 |=-
> and then nothing until (my telnet attempts before):
> 
> 2011/09/28-18:17:45 CONNECT TCP Peer: "::1:32798" Local: "::1:4949"
> Invalid netblock: 127.255.255.255-0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.1 at /usr/share/perl5/Net/Server.pm line 849
> 2011/09/28-18:25:32 CONNECT TCP Peer: "2001:15c0:66bc:0:211:11ff:fe92:3e20:33975" Local: "2001:15c0:66bc:0:211:11ff:fe92:3e20:4949"

Could this be related to the way connections are controlled in 
munin-node.conf? I have it via

  allow ^127\.0\.0\.1$
and
  allow ^$munin_server$

Do you use cidr_allow/cidr_deny?
> - Ansgar mentioned sys.net.ipv6.bindv6only on IRC.
> 
>   root@belanna:~# sysctl net.ipv6.bindv6only
>   net.ipv6.bindv6only = 1
> 
>   Oh, and setting it to 0 changes something:
> 
> root@belanna:~# telnet ::1 4949
> Trying ::1...
> Connected to ::1.
> Escape character is '^]'.
> Connection closed by foreign host.
> 
> root@belanna:~# telnet 127.0.0.1 4949
> Trying 127.0.0.1...
> Connected to 127.0.0.1.
> Escape character is '^]'.
> # munin node at belanna.comodo.priv.at
> Connection closed by foreign host.
> 
> So, with net.ipv6.bindv6only = 1 there's no ipv4 connection; with = 0
> ipv4 works.

Good catch. It seems I have 'net.ipv6.bindv6only = 0' in 
/etc/sysctl.d/bindv6only.conf. Not sure where that came from. It is 
quite possible that I have set the value at some point in the past.

Here's some interesting prose from that file:

 # This sysctl sets the default value of the IPV6_V6ONLY socket 
 # option.
 #
 # When disabled, IPv6 sockets will also be able to send and receive 
 # IPv4
 # traffic with addresses in the form ::ffff:192.0.2.1 and daemons 
 # listening
 # on IPv6 sockets will also accept IPv4 connections.
 #
 # When IPV6_V6ONLY is enabled, daemons interested in both IPv4 and 
 # IPv6
 # connections must open two listening sockets.
 # This is the default behaviour of all modern operating systems.

Yeah, right :) But the advise to open two sockets may still be useful.

> And ipv6 works connection-wise in both cases but doesn't
> generate a prompt in my telnet attempt?!

ipv6 is weird, you say? :))
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 18:36:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. Copy sent to Munin Debian Maintainers <munin-deb-maint@linpro.no>. (Wed, 28 Sep 2011 18:36:06 GMT) Full text and rfc822 format available.

Message #111 received at 523846@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: Damyan Ivanov <dmn@debian.org>, Craig Sanders <cas@taz.net.au>, 643654@bugs.debian.org, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 20:33:14 +0200
[Message part 1 (text/plain, inline)]
On Wed, 28 Sep 2011 21:12:03 +0300, Damyan Ivanov wrote:

> > 2011/09/28-18:17:45 CONNECT TCP Peer: "::1:32798" Local: "::1:4949"
> > Invalid netblock: 127.255.255.255-0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.1 at /usr/share/perl5/Net/Server.pm line 849
> > 2011/09/28-18:25:32 CONNECT TCP Peer: "2001:15c0:66bc:0:211:11ff:fe92:3e20:33975" Local: "2001:15c0:66bc:0:211:11ff:fe92:3e20:4949"
> 
> Could this be related to the way connections are controlled in 
> munin-node.conf? I have it via
> 
>   allow ^127\.0\.0\.1$
> and
>   allow ^$munin_server$
> 
> Do you use cidr_allow/cidr_deny?

Good point:

root@belanna:~# grep allow /etc/munin/munin-node.conf | grep -v ^#
allow ^127\.0\.0\.1$
cidr_allow 127.0.0.1/8
cidr_allow 192.168.0.0/24


> > - Ansgar mentioned sys.net.ipv6.bindv6only on IRC.
> > So, with net.ipv6.bindv6only = 1 there's no ipv4 connection; with = 0
> > ipv4 works.
> Good catch. It seems I have 'net.ipv6.bindv6only = 0' in 
> /etc/sysctl.d/bindv6only.conf. Not sure where that came from. It is 
> quite possible that I have set the value at some point in the past.

It broke some programs when it was introduced, so you were probably
using one of those :)
 
> > And ipv6 works connection-wise in both cases but doesn't
> > generate a prompt in my telnet attempt?!
> ipv6 is weird, you say? :))

Sounds more related to my *allow settings; in general ipv6 works
nicely :)


Yup, works. I.e. after I add allows for ipv6 addresses, I can telnet
to ::1 and I get the prompt.


Doesn't answer the "binds only to ipv6" problem, though ...


Cheers,
gregor

-- 
 .''`.   Homepage: http://info.comodo.priv.at/ - OpenPGP key ID: 0x8649AA06
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT & SPI, fellow of Free Software Foundation Europe
   `-    NP: Beach Boys: Wouldn't It Be Nice
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 19:24:03 GMT) Full text and rfc822 format available.

Message #114 received at 523846@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: 643654@bugs.debian.org
Cc: Craig Sanders <cas@taz.net.au>, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 22:21:56 +0300
[Message part 1 (text/plain, inline)]
-=| gregor herrmann, 28.09.2011 20:33:14 +0200 |=-
> Doesn't answer the "binds only to ipv6" problem, though ...

I think the answer to this is to listen on two sockets. One is the 
current implementation on listening on the ipv6's idea of "all" 
interfaces. This may fail if ipv6 is not available.

Another socket hould be opened, listening on ipv4's idea of "all" 
interfaces too. This may also fail if the ipv6 bind was successful 
*and the bindv6only setting is false*.

If both binds fail, this is fatal. If one of them is successful, 
operations can go on.

And I am not sure where this should be implemented. Meybe 
Net::Server's interface is flexible enough so that no changes would be 
necessary in munin-node…

Now, someone™ has to make some Perl code out of that prose :)
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Wed, 28 Sep 2011 20:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Munin Debian Maintainers <munin-deb-maint@linpro.no>. (Wed, 28 Sep 2011 20:06:03 GMT) Full text and rfc822 format available.

Message #119 received at 523846@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: Damyan Ivanov <dmn@debian.org>
Cc: 643654@bugs.debian.org, Craig Sanders <cas@taz.net.au>, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Wed, 28 Sep 2011 13:03:20 -0700
Damyan Ivanov <dmn@debian.org> writes:

> I think the answer to this is to listen on two sockets. One is the
> current implementation on listening on the ipv6's idea of "all"
> interfaces. This may fail if ipv6 is not available.

While opening two separate sockets is cleaner and is the maximally
portable solution, there was a long discussion about this on debian-devel
a while back (when the bind.ipv6_only setting to 1 was temporarily added
in unstable), and the conclusion was that Debian should default to 0
because that's what the IPv6 standards expected and too much software
assumes that default behavior.

People who have the setting of 1 probably got that configuration file
introduced during the time period when this was the default in unstable.
Debian never released with that setting.

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Information forwarded to debian-bugs-dist@lists.debian.org, Munin Debian Maintainers <munin-deb-maint@linpro.no>:
Bug#523846; Package munin. (Fri, 30 Sep 2011 11:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Sanders <cas@taz.net.au>:
Extra info received and forwarded to list. Copy sent to Munin Debian Maintainers <munin-deb-maint@linpro.no>. (Fri, 30 Sep 2011 11:36:10 GMT) Full text and rfc822 format available.

Message #124 received at 523846@bugs.debian.org (full text, mbox):

From: Craig Sanders <cas@taz.net.au>
To: Russ Allbery <rra@debian.org>
Cc: Damyan Ivanov <dmn@debian.org>, 643654@bugs.debian.org, 523846@bugs.debian.org
Subject: Re: Bug#643654: munin-node won't listen on ipv4 addresses after upgrading to libnet-server-perl 0.99-3
Date: Fri, 30 Sep 2011 21:34:59 +1000
On Wed, Sep 28, 2011 at 01:03:20PM -0700, Russ Allbery wrote:
> Damyan Ivanov <dmn@debian.org> writes:
> 
> > I think the answer to this is to listen on two sockets. One is the
> > current implementation on listening on the ipv6's idea of "all"
> > interfaces. This may fail if ipv6 is not available.
> 
> While opening two separate sockets is cleaner and is the maximally
> portable solution, there was a long discussion about this on debian-devel
> a while back (when the bind.ipv6_only setting to 1 was temporarily added
> in unstable), and the conclusion was that Debian should default to 0
> because that's what the IPv6 standards expected and too much software
> assumes that default behavior.
> 
> People who have the setting of 1 probably got that configuration file
> introduced during the time period when this was the default in unstable.
> Debian never released with that setting.

exactly right, i think. i'll have to clean that cruft out of my existing
systems.


i just built a brand new VM, minimal install of squeeze, immediately
upgraded to latest sid, reboot to get linux 3.0.0 kernel, then apt-get
install munin-node.

net.ipv6.bindv6only defaults to 0.

munin-node works just fine on both ipv4 and ipv6 interfaces, after
adding appropriate allow lines.

root@ztest:/etc# sysctl net.ipv6.bindv6only
net.ipv6.bindv6only = 0

root@ztest:/etc# telnet ::1 4949
Trying ::1...
Connected to ::1.
Escape character is '^]'.
# munin node at ztest.taz.net.au
list
cpu df df_inode entropy exim_mailqueue exim_mailstats forks fw_packets http_loadtime if_err_eth0 if_eth0 interrupts iostat iostat_ios irqstats load memory nfs4_client nfs_client nfsd nfsd4
open_files open_inodes proc_pri processes swap threads uptime users vmstat
quit
Connection closed by foreign host.

root@ztest:/etc# telnet localhost 4949
Trying 127.0.0.1...
Connected to localhost.
Escape character is '^]'.
# munin node at ztest.taz.net.au
list
cpu df df_inode entropy exim_mailqueue exim_mailstats forks fw_packets http_loadtime if_err_eth0 if_eth0 interrupts iostat iostat_ios irqstats load memory nfs4_client nfs_client nfsd nfsd4
open_files open_inodes proc_pri processes swap threads uptime users vmstat
quit
Connection closed by foreign host.



so this is really a host configuration error rather than a bug in either
munin-node or libnet-server-perl. at most, it'll be a documentation bug -
this issue probably needs documenting in either or both packages.

craig

-- 
craig sanders <cas@taz.net.au>




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 29 Oct 2011 07:36:54 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:20:00 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.